/*+
|                                               |
|     Trigger: DTULTATU_FILDIMEOPER             |  
|     Tabela : FILDIMEOPER                      |
|                                               |
|     Criao:                                  |
|     05/09/2007 - Luiz Passos                  |
|                                               |
+*/


create or replace TRIGGER DTULTATU_FILDIMEOPER
BEFORE INSERT OR UPDATE OR DELETE
ON FILDIMEOPER FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUFDIDWOP := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.NRSEQUEDIME,0) <> NVL(:NEW.NRSEQUEDIME,0)) OR
         (NVL(:OLD.CDOPERADOR,0) <> NVL(:NEW.CDOPERADOR,0)) OR
         (NVL(:OLD.CDFILDIMEOPER,0)  <> NVL(:NEW.CDFILDIMEOPER,0))  THEN        
         
         :NEW.DTULTATUFDIDWOP := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('FILDIMEOPER', '', 'NRSEQUEDIME='||:OLD.NRSEQUEDIME||';CDOPERADOR='||:OLD.CDOPERADOR||';CDFILDIMEOPER='||:OLD.CDFILDIMEOPER||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE FILDIMEOPER MODIFY DTULTATUFDIDWOP DEFAULT SYSDATE
/

-- VERSAO --
BEGIN ATUVEROBJ('DTULTATU_FILDIMEOPER','4.11.176'); END;
/

